class Decko_cards
  attr_reader :cards
  
  def initialize(aces=:h)
    @cards = gen(aces)
    end

  def deal
    @cards.shuffle!.pop
    end

  private
  def suits
    @suits = ['Spades', 'Diamonds', 'Clubs', 'Hearts']
    end
  
  def ranks
    @ranks = {'Two'=>2, 'Three'=>3, 'Four'=>4, 'Five'=>5,
      'Six'=>6, 'Seven'=>7, 'Eight'=>8, 'Nine'=>9, 'Ten'=>10,
      'Jack'=>10, 'Queen'=>10, 'King'=>10, 'Ace'=>11}
    end
  
  def gen(aces)
    r = ace_make(aces)
    deck_make(suits, r)
    end

  def ace_make(aces)
    r = ranks
    if aces == :l
      r['Ace']= 1
    elsif aces == :w
      r.each {
        |c, v| r[c]=Array(v)
        }
      r['Ace'] << 1
      end
    r
    end

  def deck_make(list, hash)
    d = []
    for s in list
      hash.each { |r, v|
        d << {
          :name =>"#{r} of #{s}",
          :suit =>s.to_sym,
          :rank => r.to_sym,
          :value => v
          }
        }
      end
    d
    end
  end
